package com.dtstack.encryptDemo;

import com.dtstack.encryptDemo.utils.AESUtil;
import com.dtstack.encryptDemo.utils.RSAUtil;

/**
 * 加密示例
 * @author kaiyue@dtstack.com
 * @date 2021/6/23
 */
public class EncryptDemo {

	public static void main(String[] args) throws Exception {

		// 待加密明文
		// 生成APIpost方式
		String content = "{\"inFields\":{\"id\":1}}";

		// 其他方式
//		Map<String,Object> param = new HashMap<>();
//		param.put("id",1);
//		param.put("name","张三");
//		param.put("age",20);
//		content = JSONObject.toJSONString(param);

		// 生成AES秘钥
		String aesKeyStr = AESUtil.generateKey(128);
		System.out.println("生成的aesKey:"+aesKeyStr);
		// AES加密
		String data = AESUtil.encrypt(content, aesKeyStr);
		System.out.println("请求中的data数据密文:"+data);

		// 我的API—API调用中显示的公钥
		String publicRsaKey = "MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCfN0q9T8hP3owd7jgvXWfE8R+GJLoLhtPK00+7VfQRHANxHOJdU29DDb1+CeSGrzYLf1AeUrIQ2gVS24PCKAB8/CjJSaMqmr0+yOpfNoaUr3Uuc2TersGIZDndMPZitLic8cH4jlipVvL/KOP4Ki78KBn//Y1cGKLhuqzvO7M7pwIDAQAB";
		// 通过RSA公钥对base64编码后的AES秘钥进行加密
		String aesKey = RSAUtil.encrypt(aesKeyStr, publicRsaKey);
		System.out.println("请求中的aesKey密文:"+aesKey);
	}

}
